using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using UnityEditor;
using UnityEditor.Compilation;
using UnityEditor.XR.Management;
using UnityEditor.XR.Management.Metadata;
using UnityEngine;
using UnityEngine.SceneManagement;
using UnityEngine.XR.Management;
using static MRXRSettings;

public class LoadXR
{

    private static string Path = "Build";
    /// <summary>
    /// APK
    /// </summary>
    [MenuItem("Build/Buildǰƽ̨")]
    public static void LoadXRInit()
    {
        Debug.Log("ʼ===" + DeviceType.type);
        switch (DeviceType.type)
        {
            case SDKType.SDK_Rhinox:
                initXML();
                LoadXR.LoadOnlyRhinox();
                break;
            case SDKType.SDK_Phone:
                initXML();
                LoadXR.LoadOnlyARCore();
                break;
            case SDKType.SDK_LeiNiao:

                try
                {
                    if (!Directory.Exists("Assets/Plugins/Android/"))
                    {
                        FileUtil.DeleteFileOrDirectory("Assets/Plugins/Android");
                    }
                }
                catch
                {

                }
                try
                {

                    if (File.Exists("Assets/Plugins/Android/AndroidManifest.xml.OLDOTHER"))
                    {
                        // FileUtil.DeleteFileOrDirectory("Assets/Plugins/Android/AndroidManifest.xml.OLD");
                    }
                    else
                    {
                        if (File.Exists("Assets/Plugins/Android/AndroidManifest.xml"))
                        {
                            FileUtil.CopyFileOrDirectory("Assets/Plugins/Android/AndroidManifest.xml", "Assets/Plugins/Android/AndroidManifest.xml.OLDOTHER");
                        }
                    }
                    FileUtil.DeleteFileOrDirectory("Assets/Plugins/Android/AndroidManifest.xml");
                    FileUtil.CopyFileOrDirectory("Assets/Samples/" + PackageType.LeiNiaoSDK + "/Plugins/Android/AndroidManifest.xml", "Assets/Plugins/Android/AndroidManifest.xml");
                }
                catch
                {

                }
                break;
            case SDKType.SDK_DreamGlass:

                try
                {
                    if (!Directory.Exists("Assets/Plugins/Android/"))
                    {
                        FileUtil.DeleteFileOrDirectory("Assets/Plugins/Android");
                    }
                }
                catch
                {

                }
                try
                {

                    if (File.Exists("Assets/Plugins/Android/AndroidManifest.xml.OLDOTHER"))
                    {
                        // FileUtil.DeleteFileOrDirectory("Assets/Plugins/Android/AndroidManifest.xml.OLD");
                    }
                    else
                    {
                        if (File.Exists("Assets/Plugins/Android/AndroidManifest.xml"))
                        {
                            FileUtil.CopyFileOrDirectory("Assets/Plugins/Android/AndroidManifest.xml", "Assets/Plugins/Android/AndroidManifest.xml.OLDOTHER");
                        }
                    }
                    FileUtil.DeleteFileOrDirectory("Assets/Plugins/Android/AndroidManifest.xml");
                    FileUtil.CopyFileOrDirectory("Assets/Samples/" + PackageType.OtherSDK + "/Plugins/Android/AndroidManifest.xml", "Assets/Plugins/Android/AndroidManifest.xml");
                }
                catch
                {

                }
                break;
            default:
                initXML();
                break;
        }
        AssetDatabase.Refresh();

        CompilationPipeline.RequestScriptCompilation(RequestScriptCompilationOptions.None); // ȴ

        UnityEngine.Debug.Log("RequestScriptCompilation");
        CompilationPipeline.compilationFinished += buildApkManager;
    }

    static void initXML()
    {

        try
        {

            if (File.Exists("Assets/Plugins/Android/AndroidManifest.xml.OLDOTHER"))
            {
                FileUtil.DeleteFileOrDirectory("Assets/Plugins/Android/AndroidManifest.xml");
                FileUtil.CopyFileOrDirectory("Assets/Plugins/Android/AndroidManifest.xml.OLDOTHER", "Assets/Plugins/Android/AndroidManifest.xml");
                // FileUtil.DeleteFileOrDirectory("Assets/Plugins/Android/AndroidManifest.xml.OLD");
            }
        }
        catch
        {

        }
    }

    private static void buildApkManager(object obj)
    {
        CompilationPipeline.compilationFinished -= buildApkManager;
        List<string> slist = new List<string>();
         EditorBuildSettingsScene[] scs = EditorBuildSettings.scenes;
        for (int i = 0; i < scs.Length; i++)
        {
            slist.Add(scs[i].path);


        }
        string pt = DeviceType.type;//;
        string NowTime = DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss").Replace(" ", "_").Replace("/", "_").Replace(":", "_");
        string AndroidPath = "/Android/";
        BuildPipeline.BuildPlayer(slist.ToArray(), Path + AndroidPath + pt + "_" + NowTime + ".apk", BuildTarget.Android, BuildOptions.None);


        AssetDatabase.Refresh();
        CompilationPipeline.RequestScriptCompilation(RequestScriptCompilationOptions.None); // ȴ

        UnityEngine.Debug.Log("RequestScriptCompilation");
        CompilationPipeline.compilationFinished += buildfinish;
    }

    private static void buildfinish(object obj)
    {
        initXML();
        CompilationPipeline.compilationFinished -= buildfinish;
        Debug.Log("===" + DeviceType.type);
        string index = File.ReadAllText("Build/BuildingIndex.txt");
        int nowIndx = int.Parse(index) + 1;
        File.WriteAllText("Build/BuildingIndex.txt", nowIndx.ToString());
        ALLBuild();
        /*
        AssetDatabase.Refresh();
        CompilationPipeline.RequestScriptCompilation(RequestScriptCompilationOptions.None); // ȴ

        UnityEngine.Debug.Log("RequestScriptCompilation");
        CompilationPipeline.compilationFinished += buildfinish2;*/
    }


    public static void LoadOnlyARCore()
    {
        XRGeneralSettings androidXRSettings = XRGeneralSettingsPerBuildTarget.XRGeneralSettingsForBuildTarget(BuildTargetGroup.Android);

        if (androidXRSettings == null)
        {
            var assignedSettings = ScriptableObject.CreateInstance<XRManagerSettings>() as XRManagerSettings;
            androidXRSettings.AssignedSettings = assignedSettings;
            EditorUtility.SetDirty(androidXRSettings); // Make sure this gets picked up for serialization later.
        }

        //ȡǰѡ
        IReadOnlyList<XRLoader> list = androidXRSettings.Manager.activeLoaders;
        int hasCount = list.Count;
        //Debug.Log(hasCount);
        for (int i = 0; i < hasCount; i++)
        {
            string nameTemp = list[0].GetType().FullName;
            Debug.Log("disable xr plug:" + nameTemp);
            XRPackageMetadataStore.RemoveLoader(androidXRSettings.Manager, nameTemp, BuildTargetGroup.Android);
        }

        //
        string loaderTypeName = "UnityEngine.XR.ARCore.ARCoreLoader";
        XRPackageMetadataStore.AssignLoader(androidXRSettings.Manager, loaderTypeName, BuildTargetGroup.Android);
    }
    public static void LoadOnlyRhinox()
    {
        XRGeneralSettings androidXRSettings = XRGeneralSettingsPerBuildTarget.XRGeneralSettingsForBuildTarget(BuildTargetGroup.Android);

        if (androidXRSettings == null)
        {
            var assignedSettings = ScriptableObject.CreateInstance<XRManagerSettings>() as XRManagerSettings;
            androidXRSettings.AssignedSettings = assignedSettings;
            EditorUtility.SetDirty(androidXRSettings); // Make sure this gets picked up for serialization later.
        }

        //ȡǰѡ
        IReadOnlyList<XRLoader> list = androidXRSettings.Manager.activeLoaders;
        int hasCount = list.Count;
        //Debug.Log(hasCount);
        for (int i = 0; i < hasCount; i++)
        {
            string nameTemp = list[0].GetType().FullName;
            Debug.Log("disable xr plug:" + nameTemp);
            XRPackageMetadataStore.RemoveLoader(androidXRSettings.Manager, nameTemp, BuildTargetGroup.Android);
        }

        //
        string loaderTypeName = "Ximmerse.XR.XimmerseXRLoader";
        XRPackageMetadataStore.AssignLoader(androidXRSettings.Manager, loaderTypeName, BuildTargetGroup.Android);
    }
    public static int index;
    [MenuItem("Build/һа")]
    public static void ALLBuild()
    {
        string AndroidPath = "/Android/";

        if (!Directory.Exists(Path + AndroidPath))
        {
            Directory.CreateDirectory(Path + AndroidPath);
        }

        EditorWindow.GetWindow(typeof(BuildStartPackage));
        List<string> strlist = MRXRSettings.GetAllSDKPlatform();
        File.WriteAllText("Build/BuildingChangeEnd.txt", "0");
        string index = "0";
        if (File.Exists("Build/BuildingIndex.txt"))
        {
            index = File.ReadAllText("Build/BuildingIndex.txt");
        }
        else
        {
            File.WriteAllText("Build/BuildingIndex.txt", "0");

        }
        if (strlist.Count > int.Parse(index))
        {
            File.WriteAllText("Build/BuildingStart.txt", "1");
            if (!File.Exists("Build/BuildingIndex.txt"))
            {
                File.WriteAllText("Build/BuildingIndex.txt", "0");
            }

            string pt = strlist[int.Parse(index)];
            switch (pt)
            {
                case SDKType.SDK_Nreal:
                    MRXRSettings.ChangePlatformNreal();
                    break;
                case SDKType.SDK_Phone:
                    MRXRSettings.ChangePlatformPhone();
                    break;
                case SDKType.SDK_Rhinox:
                    MRXRSettings.ChangePlatformRhinox();
                    break;
                case SDKType.SDK_DreamGlass:
                    MRXRSettings.ChangePlatformDreamGlass();
                    break;
                case SDKType.SDK_A01:
                    MRXRSettings.ChangePlatformA01();
                    break;
                case SDKType.SDK_LeiNiao:
                    MRXRSettings.ChangePlatformLeiNiao();
                    break;
                default:
                    ALLBuild();
                    break;
            }

        }
        else
        {
            File.WriteAllText("Build/BuildingStart.txt", "0");

            File.WriteAllText("Build/BuildingIndex.txt", "0");
            Debug.Log("д");
        }

    }


    public class BuildStartPackage : EditorWindow
    {
        public static void CompileScript()
        {

            AssetDatabase.Refresh();
            CompilationPipeline.RequestScriptCompilation(RequestScriptCompilationOptions.None); // ȴ
        }
        bool isBuildChnage;
        private void OnGUI()
        {

            if (EditorApplication.isCompiling)
            {
            }
            else if (isBuildChnage)
            {
                Close();

                LoadXR.LoadXRInit();
            }


            if (!isBuildChnage && File.ReadAllText("Build/BuildingChangeEnd.txt") == "1")
            {
                isBuildChnage = true;
                CompileScript();
            }
        }
    }

    private static void StartbuildApk()
    {
        index++;
        //ShowSelectionDialog();
        MyScript.CompileScript();

    }
    private static void ShowSelectionDialog()
    {
        // 
        string title = "ѡʾ";

        // 
        string message = "";

        // ťǩ
        string okButton = "ǵ";
        string cancelButton = "ȡ";

        // ʾѡ
        bool result = EditorUtility.DisplayDialog(title, message, okButton, cancelButton);

        // ûѡ
        if (result)
        {
            LoadXR.LoadXRInit();
            // û "ǵ" ť
            // EditorUtility.DisplayDialog("", "ѡ˼", "ȷ");
        }
        else
        {
            // û "ȡ" ť
            //  EditorUtility.DisplayDialog("", "ѡȡ", "ȷ");
        }
    }

    public class MyScript : EditorWindow
    {
        public static void CompileScript()
        {
            CompilationPipeline.RequestScriptCompilation(RequestScriptCompilationOptions.None); // ȴ
            EditorWindow.GetWindow(typeof(MyScript));
        }
        private void OnGUI()
        {
            if (EditorApplication.isCompiling)
            {
                UnityEngine.Debug.Log("ʼ22222" + EditorApplication.isCompiling);
            }
            else
            {
                Close();
                UnityEngine.Debug.Log("űɡ");
                LoadXR.LoadXRInit();
            }
        }
    }
}
